//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
  
// I want to thank Michal Rutka, michal1@zonnet.nl, for helping me correct
// the mistakes that I made... Good Job!!

#property copyright "Provided by sencho, coded by don_forex, modified by TR"

extern int     TakeProfit = 60;
extern double  StopLoss = 30;
extern int     TrailingStop = 15;
extern int     PipDifference = 15;
extern bool    EnableMM? = false;
extern double  LotsIfNoMM = 1.0;
extern double  MaximumRiskIfMM = 10;
extern bool    UseHourTrade = False;
extern int     FromHourTrade = 8;
extern int     ToHourTrade = 18;

double LastLogTime,NoTouchBarLong,NoTouchBarShort;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start(){
   if (UseHourTrade){
   if(!(Hour()>=FromHourTrade&&Hour()<=ToHourTrade)){
   Comment("Non-Trading Hours!");
   return(0);
   }
   }
   int cnt, ticket;
   if(Bars<100){
      Print("Bars Less than 100");
      return(0);
   }
   if(TakeProfit<10){
      Print("TakeProfit Less than 10");
      return(0);
   }
   string TradeSymbol      = Symbol();
   double MA144H           = MathRound(iMA(NULL,0,144,0,MODE_EMA,PRICE_HIGH,1)/Point)*Point;
   double MA144L           = MathRound(iMA(NULL,0,144,0,MODE_EMA,PRICE_LOW,1)/Point)*Point;
   double Spread           = Ask-Bid; // MarketInfo(TradeSymbol,MODE_SPREAD);
   double BuyPrice         = MA144H +Spread+PipDifference*Point;
   double BuyStopLoss      = BuyPrice -StopLoss*Point;
   double BuyTakeProfit    = BuyPrice +TakeProfit*Point;
   double SellPrice        = MA144L -Spread+PipDifference*Point;
   double SellStopLoss     = SellPrice +StopLoss*Point;
   double SellTakeProfit   = SellPrice -TakeProfit*Point;
   double lot;
   double close            =iClose(NULL,0,1);
   int total               =OrdersTotal();
   
   if (EnableMM?) lot=NormalizeDouble(AccountFreeMargin()*MaximumRiskIfMM/50000,1);
      else lot=LotsIfNoMM;
   
   bool need_long  = true;
   bool need_short = true;
   for(cnt=0;cnt<total;cnt++) {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderMagicNumber() == 16384){
         if(OrderType() == OP_BUY){
            need_long = false;
            NoTouchBarLong=iTime(NULL,0,0);
            if (OrderStopLoss()<BuyStopLoss){
               Print(BuyStopLoss, " ",OrderStopLoss());
               OrderModify(OrderTicket(),OrderOpenPrice(),BuyStopLoss,BuyTakeProfit,1,Blue);
            }
            if(TrailingStop>0) {
               if(Bid-OrderOpenPrice()>Point*TrailingStop) {
                  if(OrderStopLoss()<Bid-Point*TrailingStop) {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),1,Blue);
                  }
               }
            }
         }
         if(OrderType() == OP_SELL){
            need_short = false;
            NoTouchBarShort=iTime(NULL,0,0);
            if (OrderStopLoss()>SellStopLoss){
               Print(SellStopLoss, " ",OrderStopLoss());
               OrderModify(OrderTicket(),OrderOpenPrice(),SellStopLoss,SellTakeProfit,1,Blue);
               //OrderDelete(OrderTicket());
            }
            if(TrailingStop>0) {
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop)) {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0)) {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),1,Red);
                  }
               }
            }
         }
      }
   }
      
   if(AccountFreeMargin()<(1000*lot)){
      Print("We Have NO Money. Free Margin = ", AccountFreeMargin());
      return(0);
   }
       
      if(need_long && iTime(NULL,0,0)!=NoTouchBarLong)
         {
         if (BuyPrice<Bid+Point*10) 
            ticket=OrderSend(Symbol(),OP_BUY,lot,Ask,10,BuyStopLoss,BuyTakeProfit,"Binario_v3",16384,1,Blue);
         }
      if(need_short && iTime(NULL,0,0)!=NoTouchBarShort)
         {
         if (SellPrice>Ask-Point*10) 
            ticket=OrderSend(Symbol(),OP_SELL,lot,Bid,10,SellStopLoss,SellTakeProfit,"Binario_v3",16384,1,Red);
         }
}


